
; ========================================================
;			
;    -- Sounder.asm --
;			Jay Sullivan
; ========================================================
  

.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------


	;----------------------------
	;     Includes
	;----------------------------
		
		include Sounder.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		PlayNote PROTO psignal:DWORD
		ThreadProc PROTO lParam:LPVOID
		SoundTriggerFromMenu PROTO id:DWORD
		CFret_WndProc PROTO hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	;----------------------------
	;     Macros
	;----------------------------
		
		SetNotes MACRO at0,at1,at2, at3, at4, at5
			push at0*112+8
			push at1*112+8
			push at2*112+8
			push at3*112+8
			push at4*112+8
			push at5*112+8
			pop NoteChooserX[4*5]
			pop NoteChooserX[4*4]
			pop NoteChooserX[4*3]
			pop NoteChooserX[4*2]
			pop NoteChooserX[4*1]
			pop NoteChooserX[4*0]
			
			
			if at0 ge 0
  				MakeThreadNote 0, at0, -1
  			endif
			if at1 ge 0
  				MakeThreadNote 1, at1, -1
  			endif
			if at2 ge 0
  				MakeThreadNote 2, at2, -1
  			endif
			if at3 ge 0
  				MakeThreadNote 3, at3, -1
  			endif
			if at4 ge 0
  				MakeThreadNote 4, at4, -1
  			endif
			if at5 ge 0
  				MakeThreadNote 5, at5, -1
  			endif
		ENDM
		
		
		
		MakeThreadNote MACRO StrNum, Index, Tme
				push FrequencyTable[Index*4]
				pop String&StrNum&.ThreadSignalInfo.FREQ
				push &Tme&
				pop String&StrNum&.ThreadSignalInfo.TIME
	        invoke CreateThread,0,0,Offset ThreadProc, Offset String&StrNum&, 0,0
	        mov String&StrNum&.ThreadSignalInfo.hThread, eax
	        ;invoke SetThreadPriority,eax, 15
		ENDM
		
		
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke GetProcessHeap
		mov hHeap, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG


	;------------------------------------------------
	;	Windows
	;------------------------------------------------
	;------------------------------------------------
	;	Main Window Class
	;------------------------------------------------
			;-----------------------------
			;	Register
			;-----------------------------
				mov wc.cbSize, Sizeof WNDCLASSEX
				mov wc.style, CS_HREDRAW or CS_VREDRAW
				mov wc.lpfnWndProc, Offset WndProc
				mov wc.cbClsExtra,0
				mov wc.cbWndExtra,0
				mov eax,hInst
				mov wc.hInstance,eax
				mov wc.hbrBackground, COLOR_WINDOW+1
				mov wc.lpszMenuName, NULL
				mov wc.lpszClassName, Offset ClassName
				invoke LoadIcon, NULL, IDI_APPLICATION
				mov wc.hIcon,eax
				mov wc.hIconSm,0
				invoke LoadCursor, NULL, IDC_ARROW
				mov wc.hCursor,eax
				invoke RegisterClassEx, ADDR wc
				invoke LoadMenu, hInst, IDM_MNU
				mov hMenu,eax
			;-----------------------------
			;	Create
			;-----------------------------
				invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
					WS_OVERLAPPEDWINDOW,\
					CW_USEDEFAULT,CW_USEDEFAULT,700,270,\
					NULL,hMenu,hInst,NULL
				mov hwnd,eax
				

			
			
		;-----------------------------
		;	Fret Buttons
		;-----------------------------
			
			;-----------------------------
			;	Register
			;-----------------------------
				mov wc.cbSize, Sizeof WNDCLASSEX
				mov wc.style, CS_HREDRAW or CS_VREDRAW 
				mov wc.lpfnWndProc, Offset CFret_WndProc
				mov wc.cbClsExtra,NULL
				mov wc.cbWndExtra,4
				mov eax,hInstance
				mov wc.hInstance,eax
				mov wc.hbrBackground, COLOR_WINDOW+15
				mov wc.lpszMenuName, NULL
				mov wc.lpszClassName, Offset CFret_ClassName
				invoke LoadIcon, NULL,IDI_HAND
				mov wc.hIcon,eax
				mov wc.hIconSm,0
				invoke LoadCursor, NULL,IDC_HAND
				mov wc.hCursor,eax
				invoke RegisterClassEx, ADDR wc
			;-----------------------------
			;	Create
			;-----------------------------
							
				EDITFLAGS equ WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT
				EDITEXSTYLE equ WS_EX_STATICEDGE
				EDITWIDTH equ 111
				EDITHEIGHT equ 30
				EDITLEFT equ 8
				EDITTOP equ 8
			
			
				forc L, <012345>
				
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+0*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+0
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+1*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+1
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+2*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+2
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+3*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+3
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+4*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+4
				invoke CreateWindowEx, EDITEXSTYLE , ADDR CFret_ClassName, 0, EDITFLAGS, EDITLEFT+L*(EDITWIDTH+1),EDITTOP+5*(EDITHEIGHT+3),EDITWIDTH,EDITHEIGHT, hwnd,0,hInst,L*256+5

				endm

		;-----------------------------
		;	Shtuff
		;-----------------------------
				
			invoke LoadBitmap,hInst,bmpGuitar
			mov g_hbmGuitar, eax
			invoke LoadBitmap,hInst,bmpNote
			mov g_hbmNote, eax
			
		;-----------------------------
		;	MakeDCShade
		;-----------------------------
			call MakeDCShade
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------

		
		
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			  
			  
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		call KillDCShade
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
	;;;;;;;;;;;;;;;;;;;;;;;;
	;;;;;;;;;;;;;;;;;;;;;;;
	;;;;;; THIS SECTION IS FOR CHORDS
	;;;;;;;;;;;;;;;;;;;;;;;
	;;;;;;;;;;;;;;;;;;;;;;;;
		
		mov eax,wParam
		
		;-----------------------------
		 .if ax== BN_CLICKED || ax==IDM_Note_Clear
		;-----------------------------
	 		mov ecx, lParam
			.if ecx==hButtonClear || ax==IDM_Note_Clear
				SetNotes -2,-2,-2,-2,-2,-2
				forc x, <012345>
				 ; A word of wisdom: make sure the event is created as Manual Reset, 
				 ; or else only one thread will receive this trigger.
				 invoke SetEvent,dword ptr [String&x&.ThreadSignalInfo.fDONE] 
				 mov  dword ptr [String&x&.ThreadSignalInfo.fDONE], 0
				 invoke CloseHandle, dword ptr [String&x&.ThreadSignalInfo.fDONE]
				endm
			.elseif ecx==hButtonE
				SetNotes 0,-2,-2,-2,-2,-2
			.elseif ecx==hButtonF
				SetNotes 1,-2,-2,-2,-2,-2
			.elseif ecx==hButtonFS
				SetNotes 2,-2,-2,-2,-2,-2
			.elseif ecx==hButtonG
				SetNotes 3,-2,-2,-2,-2,-2
			.elseif ecx==hButtonGS
				SetNotes 4,-2,-2,-2,-2,-2
			.elseif ecx==hButtonA
				SetNotes 5,-2,-2,-2,-2,-2
			.endif
			
			invoke InvalidateRect,hWnd,0,TRUE
			
		
		;-----------------------------
		 .elseif ax >= 4000 && ax <= 4085
		;-----------------------------
		; 4000FFSS
			invoke SoundTriggerFromMenu, eax
			invoke InvalidateRect,hWnd,0,TRUE
		        
				
		;-----------------------------
		 .endif
		;-----------------------------
		
	;-----------------------------
	 .elseif uMsg==WM_PAINT 
	;-----------------------------
	
     ; make new dc and stamp old
		invoke BeginPaint,hWnd, Offset ps
		mov hdc, eax
        invoke CreateCompatibleDC, hdc
        mov hdcMem, eax
	 ; draw
        invoke SelectObject,hdcMem, g_hbmGuitar
		mov hbmOld, eax
        invoke BitBlt,hdc, 0, 0, 700, 215, hdcMem, 0, 0, SRCCOPY 
 
        invoke SelectObject,hdcMem, hbmOld
        invoke DeleteDC,hdcMem
        invoke EndPaint,hWnd, Offset ps

	
	
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


itoaStack PROC uses ebx i:DWORD, pStr:DWORD
    mov ebx,10
	mov eax, i
	mov ecx, pStr
	
	  sub esp, 1			; .. push byte
	  mov byte ptr [esp], 0 ; .. push byte
repzz:
	xor edx,edx
	div ebx		; divide ebx by 10, put remainder in edx
	add edx, 30h
	  sub esp, 1			 ; .. push byte
	  mov byte ptr [esp], dl ; .. push byte
	test eax, eax
	jnz repzz
	
	xor eax, eax
unrepzz:
	 mov al, byte ptr [esp] ; ... pop byte
	 mov byte ptr [ecx], al ; ... pop byte
	 add esp, 1				; ... pop byte
	add ecx, 1
	test eax, eax
	jnz unrepzz
	
	
	Ret
itoaStack ENDP

;signal.FREQ:REAL4,
;signal.TIME:DWORD, 
PlayNote PROC psignal:DWORD
LOCAL i:DWORD,             ; temporary sample#
     sample:DWORD,		   ; temporary sample storage
     hWaveOut   :HANDLE,   ; handle to sound card
     myWaveHeader:WAVEHDR, ; wave header struct
     mySoundBuffer[MaxSoundSize]:BYTE ; waveform buffer
     
     mov esi, psignal
     assume esi:ptr ThreadSignalInfo
     
    ; .if dword ptr [esi.ThreadSignalInfo.fDONE] != 0
    ;   ret
    ; .endif
	;-----------------------------
	;	Initialize myWaveHeader
	;-----------------------------
	 lea eax, mySoundBuffer
	   mov myWaveHeader.WAVEHDR.lpData, eax
	   ;mov myWaveHeader.WAVEHDR.dwBufferLength, MaxSoundSize
	   mov myWaveHeader.WAVEHDR.dwFlags, WHDR_BEGINLOOP or WHDR_ENDLOOP
	   mov myWaveHeader.WAVEHDR.dwLoops, -1
	;-----------------------------
	;	Calculate FullSinWave in bytes
	;-----------------------------
	 RoundingMode 11
	 	fild dword ptr $Const(wf_nSamplesPerSec*2*wf_nChannels)
	 	fdiv real4 ptr [esi.ThreadSignalInfo.FREQ]
	 	fistp myWaveHeader.WAVEHDR.dwBufferLength
	 	;-----------------------------
		;	Message box to display sine wave width
		;-----------------------------
		 	;invoke itoaStack,i,Offset dumpBuffer
		 	;invoke MessageBox,0,Offset dumpBuffer,Offset szAppName,MB_OK

		;-----------------------------
		;	Open the audio device 
		;-----------------------------
			
			invoke waveOutOpen,ADDR hWaveOut,0, ADDR WaveFormat,0,0, CALLBACK_NULL
	
		;---------------------------------------
		;	sin( i * sinmulti )  * 127   + 128
		;	sin( i * sinmulti )  * 32767 + 0
		;---------------------------------------
			
			if wf_wBitsPerSample eq 8
				SinAmplitude equ 127
				SinMidpoint  equ 128
			elseif wf_wBitsPerSample eq 16
				SinAmplitude equ 32767
				SinMidpoint  equ 0
			elseif wf_wBitsPerSample eq 24
				SinAmplitude equ 8388607
				SinMidpoint  equ 0
			endif
			
			;-----------------------------
			;	"sinmulti" = PI*Frequency/SamplesPerSecond
			;-----------------------------
				fldpi
				;fimul $Const(2)
				fmul real4 ptr [esi.ThreadSignalInfo.FREQ]
				fidiv dword ptr $Const(wf_nSamplesPerSec); (x2) ? channels
				fst st(1)
				
			;-----------------------------
			;	Make the sound buffer
			;-----------------------------
			xor ecx, ecx
			mov edx, myWaveHeader.WAVEHDR.dwBufferLength
			mov i, 0
			MakeSoundBuffer:
			
				fld st(1)
				fimul i
				fsin
				fimul dword ptr $Const(SinAmplitude)
				if SinMidpoint ne 0
					fiadd dword ptr $Const(SinMidpoint)
				endif
				fistp sample
				
				mov eax, sample
				repeat wf_nChannels
					if wf_wBitsPerSample eq 8
						mov byte ptr mySoundBuffer[ecx], al
					elseif wf_wBitsPerSample eq 16
						mov word ptr mySoundBuffer[ecx], ax
					elseif wf_wBitsPerSample eq 24
						mov dword ptr mySoundBuffer[ecx], eax
					endif
				    add i, wf_wBitsPerSample / 8
			    endm
			    
				mov ecx, i
			    cmp ecx,  edx
			    jb MakeSoundBuffer

				
			;-----------------------------------------------------------
			;	  Prepare the header for playback on sound card
			;-----------------------------------------------------------
			
				invoke waveOutPrepareHeader,hWaveOut,ADDR myWaveHeader,Sizeof myWaveHeader
				
			;-----------------------------------------------------------
			;	  ** Play the sound! **
			;-----------------------------------------------------------
		;-----------------------------
		;	Create finish event
		;-----------------------------
			
			.if dword ptr [esi.ThreadSignalInfo.fDONE] == 0
				invoke CreateEvent, 0, TRUE, FALSE, 0
				mov dword ptr [esi.ThreadSignalInfo.fDONE], eax
				invoke ResetEvent,dword ptr [esi.ThreadSignalInfo.fDONE]
			.endif
			
				invoke waveOutWrite,hWaveOut,ADDR myWaveHeader,Sizeof myWaveHeader
				invoke WaitForSingleObject,dword ptr [esi.ThreadSignalInfo.fDONE], dword ptr [esi.ThreadSignalInfo.TIME]
				invoke waveOutReset,hWaveOut
				
			;-----------------------------------------------------------
			;	  Done.  Unload crap.
			;-----------------------------------------------------------
			
				invoke waveOutUnprepareHeader,hWaveOut,ADDR myWaveHeader,Sizeof myWaveHeader
				invoke waveOutClose,hWaveOut
				;invoke CloseHandle, dword ptr [esi.ThreadSignalInfo.fDONE]
	
		;-----------------------------
		;-----------------------------
		;-----------------------------
		
	ret
PlayNote ENDP




ThreadProc PROC pString:LPVOID
	invoke PlayNote,pString
	ret
ThreadProc ENDP



SoundTriggerFromMenu PROC id:DWORD
LOCAL stringIndex:DWORD,
	  fretIndex:DWORD,
	  freqIndex:DWORD
				
				and eax, 0000FFFFh
				sub eax, 4000
							 ; eax = (16*string + fret)
				
			;-----------------------------------------------------------
			;	  Get stringIndex
			;-----------------------------------------------------------
			
				mov ecx, eax ;
				shr eax, 4 	 ; eax = (string)
				mov stringIndex, eax
			
			
			
			
			;-----------------------------------------------------------
			;	 Get fretIndex
			;-----------------------------------------------------------
			
				and ecx, 0Fh	; ecx = (fret)
				mov fretIndex, ecx
				
			;-----------------------------------------------------------
			;	  get frequency
			;-----------------------------------------------------------
				
				mov edx, eax ;
				add eax, edx ;  
				add eax, edx ;
				shl eax, 1   ; eax = (string * 6)
				
				mov freqIndex, eax ;  index = (string*6)
				add freqIndex, ecx ;   index = (string*6 + fret)
				
				
				
			;-----------------------------------------------------------
			;	  Close old event
			;-----------------------------------------------------------
				mov ecx, stringIndex
				shl ecx, 4
				invoke SetEvent,dword ptr [String0.ThreadSignalInfo.fDONE+ecx]
				mov ecx, stringIndex
				shl ecx, 4
				mov  dword ptr [String0.ThreadSignalInfo.fDONE+ecx], 0
				invoke CloseHandle, dword ptr [String0.ThreadSignalInfo.fDONE+ecx]
				
				
			;-----------------------------------------------------------
			;	  get frequency
			;-----------------------------------------------------------
				
				
				
				
				
				mov ecx, freqIndex
				mov eax, stringIndex
				shl eax, 4 
				
				push FrequencyTable[ecx*4]
				pop  String0.FREQ[eax]
				mov String0.TIME[eax], -1
				add eax, Offset String0
				
			;-----------------------------------------------------------
			;	Make note
			;-----------------------------------------------------------
				
				
		        invoke CreateThread,0,0,Offset ThreadProc, eax, 0,0
		        mov ecx, stringIndex
		        shl ecx, 4
		        mov String0.hThread[ecx], eax
		        
		        
			;-----------------------------------------------------------
			;	  Visual Set
			;-----------------------------------------------------------
				mov eax, fretIndex
				mov ecx, stringIndex
				
				mov StringIndex0[ecx*4], eax
				comment ^
		        xor edx, edx
		        mov eax, fretIndex
		        mov ecx, 112
		        mul ecx    
		        add eax, 8          ; fretIndex * 112 + 8
		        mov ecx, stringIndex
				mov NoteChooserX[ecx*4], eax
				^
				
	ret
SoundTriggerFromMenu ENDP




;------------------------------------------------
;	This is a button on the window
;------------------------------------------------
MakeDCShade PROC
        invoke CreateCompatibleDC, 0
        mov hdcShade, eax
        invoke SelectObject,hdcShade, g_hbmNote
	ret
MakeDCShade ENDP
KillDCShade PROC
	invoke DeleteDC,hdcShade
	ret
KillDCShade ENDP


FretStruct STRUCT
	ID 		dd ?
	;state	dd ?
FretStruct ENDS
CFret_WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL myHdc:HDC, bPaint:BOOL,
	  hPen:HPEN, bOpaque:DWORD,
	  myStr:DWORD, myRect:RECT,
	  myColor:DWORD, pUserData:DWORD

	mov eax, uMsg
	;-----------------------------
	 .if eax==WM_PAINT 
	;-----------------------------
	
		invoke GetWindowLong,hWnd,GWL_USERDATA
		mov eax, [eax].FretStruct.ID
		mov ecx, eax
		and eax, 0FFh;  << String #
		shr ecx, 8   ;  << Fret #
		
		
		cmp StringIndex0[4*eax], ecx
		sete al
		mov bPaint, eax
		
	;-----------------------------
	;  Get Info
	;-----------------------------
	
	
		invoke BeginPaint,hWnd,ADDR ps
		mov myHdc, eax
		
		.if bPaint!=0
       		invoke BitBlt,myHdc, 0, 0, 111, 31, hdcShade, 0, 0, SRCAND
 		.endif
 		
        invoke EndPaint,hWnd, Offset ps
		

	;-----------------------------
	 .elseif eax==WM_ERASEBKGND  ; (wParam = DC)
	;-----------------------------
	
	;-----------------------------
	 .elseif eax==WM_CREATE
	;-----------------------------
		mov eax, lParam
		push [eax]
		invoke HeapAlloc,hHeap,0,Sizeof FretStruct
		;mov dword ptr [eax].FretStruct.state, 0
		pop dword ptr [eax].FretStruct.ID
		invoke SetWindowLong,hWnd,GWL_USERDATA, eax
		
		
	;-----------------------------
	 .elseif eax==WM_MOUSEACTIVATE
	;-----------------------------
	
		invoke GetWindowLong,hWnd,GWL_USERDATA
		mov edx, eax
		mov eax, [eax].FretStruct.ID
		mov ecx, eax
		and ecx, 0FFh;  << String #
		shr eax, 8   ;  << Fret #
		
		;-----------------------------
		;  Make negative if it's already selected
		;-----------------------------
	.if StringIndex0[4*ecx]==eax
		mov StringIndex0[4*ecx], -1
	.else
		mov StringIndex0[4*ecx], eax
	.endif
		
			;cmp StringIndex0[4*ecx], eax
			;sete ah
			;cwd
			;mov StringIndex0[4*ecx], eax
		
		invoke InvalidateRect,hwnd, 0, TRUE
		  	
	;-----------------------------
	 .else
	;-----------------------------
	
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
CFret_WndProc ENDP
End Start